#!ruby -Ks

require 'date'
require 'erb'
require 'win32ole'

MDB_FILE = ARGV[0]
SAVE_FILE = ARGV[1]
EXE_FILE = ARGV[2]

# ʂ̃Gg[(MonthArray)
$MONTHLY_ENTREIS = []
# Gg[IDƃGg[Hash(VGg[ID)
$ENTRY_TABLE = {}
# JeS[IDƃJeS[Hash
$CATEGORY_TABLE = {}
#t̉͂ɎsĂƂ 1899/12/30 00:00:00
$ERROR_DATE = Date.new(1899, 12, 30)

class ADOconn
  def initialize()
    @ado = WIN32OLE.new('ADODB.Connection')
  end

  def close
    @ado.Close
  end

  def open(file, password = '')
    constr = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=%s;ms access;pwd=%s"
    @ado.Open sprintf(constr, file, password)
  end
  
  def query(sql)
    rs  = @ado.Execute(sql)
    unless rs.State == 0 # 1 as return Recordset Object
      result = []
      until rs.EOF
        l = []
        for r in rs.Fields
          l << r.Value
        end
        result << l
        rs.MoveNext
      end
      rs.Close
      return result
    else
      return true
    end
  end
end

# ʃGg[
class Month
  attr_accessor :date #N
  attr_accessor :entries #̃Gg[(Entry̔z)
  def initialize
    @entries = []
    @date = Date.new(9999,12,31)
  end
  # N
  def equal_month?(date)
    # ͂Ɏst̎́AtƌȂ
    return true if @date === $ERROR_DATE or @date === $ERROR_DATE
    @date.year == date.year and @date.month == date.month
  end
end

# Gg[
class Entry
  attr_accessor :id # Gg[ID(ʂ̔ԍ)
  attr_accessor :date # Gg[̓t
  attr_accessor :url # Gg[URL
  attr_accessor :title # Gg[̃^Cg
  attr_accessor :comment # Gg[̃Rg
  attr_accessor :categories # JeS[
  def initialize
    @categories = []
  end
end

# JeS[
class Category
  attr_accessor :id # JeS[ID
  attr_accessor :url # JeS[URL
  attr_accessor :name # JeS[
  attr_accessor :entries # JeS[̃Gg[(Entry̔z)
  def initialize
    @entries = []
  end
end

# ݒ擾
def load_conf(ado)
  ret = {}
  ado.query('select name, data from html').each do |row|
    name = row[0]
    data = row[1]
    ret[name] = data
  end
  ret
end

# ʂ̃Gg[ $MONTHLY_ENTRIES ɓo^
def load_monthly_entries(ado)
  $MONTHLY_ENTREIS.clear
  $ENTRY_TABLE.clear

  month = Month.new
  ado.query('SELECT id, url, ^Cg, t, Rg FROM entries ORDER BY id DESC').each do |row|
    entry = Entry.new
    entry.id = row[0]
    entry.url = row[1]
    entry.title = row[2]
    entry.date = Date.parse(row[3]) #t̉͂ɎsĂƂ 1899/12/30 00:00:00
    entry.comment = row[4]
    $ENTRY_TABLE[entry.id] = entry

    #ς
    unless month.equal_month?(entry.date)
      month = Month.new
      month.date = entry.date
      $MONTHLY_ENTREIS << month
    end
    month.entries << entry
  end
end

# JeS[擾A$CATEGORY_TABLE ɓo^
def load_categories(ado)
  $CATEGORY_TABLE.clear

  ado.query('select id,name,url from categories order by id').each do |row|
    category = Category.new
    category.id = row[0]
    category.name = row[1]
    category.url = row[2]
    category.name = '' if category.name.strip.size == 0
    $CATEGORY_TABLE[category.id]=  category
  end
end

# Gg[̃JeS[擾A$ENTRY_TABLE  $CATEGORY_TABLE ɐݒ肷
def load_entreis_categories(ado)
  ado.query('select entry_id,category_id from entries_categories').each do |row|
    entry_id = row[0]
    category_id = row[1]
    $ENTRY_TABLE[entry_id].categories << $CATEGORY_TABLE[category_id]
    $CATEGORY_TABLE[category_id].entries << $ENTRY_TABLE[entry_id]
  end
end

# mdb_file MDBt@C̃pX
# save_file 쐬t@C̃pX
# exe_file svÕpX
def main(mdb_file, save_file, exe_file)
  # t@Č
  raise "ۑt@Cݒ肳Ă܂B" if save_file.nil? or save_file == ''
  raise "mdbt@C܂B\n#{mdb_file}" if mdb_file.nil? or not FileTest.exist?(mdb_file)

  # s
  ado = ADOconn.new()
  ado.open(mdb_file)
  config = load_conf(ado)
  load_categories(ado)
  load_monthly_entries(ado)
  load_entreis_categories(ado)
  ado.close

  # ev[gt@C
  dir = File.dirname(File.expand_path(exe_file))
  tmpl = open(dir + '/template.html').read

  # HTMLt@C̏o
  include ERB::Util
  open(save_file, 'w') do |f|
    f.puts ERB.new(tmpl).result(binding)
  end

end

if $0 == __FILE__
  begin
    main(MDB_FILE, SAVE_FILE, EXE_FILE)
    # mdbt@C폜
    File.delete(MDB_FILE)
    # Ƃ߂郁bZ[W\
    puts 't@C쐬܂B'
    sleep(1)
  rescue => e
    # G[Ƃ́AG[bZ[W\A10bҋ@
    puts e
    sleep(10)
  end
end
